<?php 
/* COPYRIGHT 2005-2006, MANUEL ALDANA, aldana@gmx.de
 * $LastChangedRevision: 227 $
 * $LastChangedDate: 2006-05-17 00:15:45 +0200 (Mi, 17 Mai 2006) $ */

//MODULE FOR OUTPUT OF HTML-HEADER STUFF

//don't allow direct access
if (!defined('MOD_LOAD_ALLOWED')){
	//for search engines to ignore content with 404 code
	//and users which cannot run this php-script
	header("HTTP/1.x 404 Not Found");
	exit;
} 

//for access to xml config file
include_once($_SERVER['DOCUMENT_ROOT'].'/cms/modules/xml_config_access.php5');

//link element implemented as composite design pattern
//link element maps to one content item
class PathElement{
	var $identifier;
	var $name;		
	var $pathParent;
	var $pathChild;
	
	function __construct($identifier,$name){
		$this->identifier=$identifier;
		$this->name=$name;
	}
	
	function hasChildPathElement(){
		if($this->pathChild!=NULL)
			return true;
		return false;			
	}
	
	function getParent(){
		return $this->pathParent;
	}
	
	function getPathChild(){
		return $this->pathChild;
	}
	
	function addParentPathElement($pathParent){
		//bidirectional relation
		$this->pathParent=$pathParent;
		$pathParent->pathChild=$this;
	}

}


//holds reference to website's current displayed content item
class ContentPath{
	
	//points to root of path
	var $pathRoot;
	var $pathLeaf;
	
	function __construct($pathElement){
		//while init there is only one pathElement, it is both leaf and root
		$this->pathRoot=$pathElement;
		$this->pathLeaf=$pathElement;
	}
	
	function addParentPathElement($pathElement){
		$this->pathRoot->addParentPathElement($pathElement);
		//just created parent is new root
		$this->pathRoot=$this->pathRoot->pathParent;
	}
					
}

function createLinkElement($linkIdentifier){
	//print "create new link element $linkIdentifier";
	return new PathElement($linkIdentifier,getNameByLink($linkIdentifier));
}

//function getContentPath($linkIdentifier){
//	//for iterating
//	$linkIdentifierTemp=$linkIdentifier;
//	$contentPath=new ContentPath(createLinkElement($linkIdentifierTemp));
//	while(hasParent($linkIdentifierTemp)){
//		$linkIdentifierTemp=getParentLink($linkIdentifierTemp);
//		$contentPath->addParentPathElement(createLinkElement($linkIdentifierTemp));
//	}				
//	//points to current displayed item 
//	//print var_dump($contentPath);
//	return $contentPath;
//}

function getContentPath($linkIdentifier){
	//for iterating
	$linkIdentifierTemp=$linkIdentifier;
	$contentPath=new ContentPath(createLinkElement($linkIdentifierTemp));
	while(hasParent($linkIdentifierTemp)){
		$linkIdentifierTemp=getParentLink($linkIdentifierTemp);
		$contentPath->addParentPathElement(createLinkElement($linkIdentifierTemp));
	}		
	//points to current displayed item 
	//print var_dump($contentPath);
	return $contentPath;
}

function getParentLink($linkIdentifier){
	asserts(hasParent($linkIdentifier),'Link must have a parent!');
	preg_match('/(\w+)\/\s*$/',getContentItemCategoryByLink($linkIdentifier),$array);
	return $array[1];
}

function getRootPathElement(){
	return getContentPath(getCurrentLink())->pathRoot;
}

function getLeafPathElement(){
	return getContentPath(getCurrentLink())->pathLeaf;
}

function getCurrentLink(){
	return $_GET['content']; 
}

function getPathOfContent(){
	//path is path in config-xml appended with link identifier itself
	return getContentItemCategoryByLink(getCurrentLink()).'/'.getCurrentLink().'.php5';
}

function getCurrentContentItem(){
	return getContentItemByLink(getCurrentLink());
}

function hasParent($linkIdentifier){
	//has parent if there is an identifier left to last slash '/'
	if(preg_match('/(\w+)\/\s*$/',getContentItemCategoryByLink($linkIdentifier)))
		return true;
	return false;		 	
}


?>