<?php 
/* COPYRIGHT 2005-2006, MANUEL ALDANA, aldana@gmx.de
 * $LastChangedRevision: 227 $
 * $LastChangedDate: 2006-05-17 00:15:45 +0200 (Mi, 17 Mai 2006) $ */

//FOR ACCESSING XML CONFIG FILE

//don't allow direct access
if (!defined('MOD_LOAD_ALLOWED')){
	//for search engines to ignore content with 404 code
	//and users which are not allowed to run this php-script directly
	header("HTTP/1.x 404 Not Found");
	exit;
} 

include_once($_SERVER['DOCUMENT_ROOT'].'/cms/modules/asserts.php5');


//CMS-Config dom object, which represents cms_config.xml
class CMS_Config extends DomDocument {
	function __construct() {
		parent :: __construct();
	}

	function parse() {
		if (!defined(DOC_ROOT))
			define(DOC_ROOT, $_SERVER['DOCUMENT_ROOT']);
		parent :: load(DOC_ROOT.'/cms/config/cms_config.xml');
	}
}

function createXPathQueryObject() {
	//static, so it does not need to be initialized again at each call
	static $xp;
	if (!$xp) {
		$cmsConfig = new CMS_Config();
		$cmsConfig->parse();
		//xpath object for querying    
		$xp = new domxpath($cmsConfig);
	}
	return $xp;
}

function getAttributeValue($DOMElement,$attributeName){
	 //utf8_decode, because xml config file encoding is latin1, but internally php wraps dom elements
	 //as utf -> to get latin1-chars stuff needs to be decoded first 
	 return utf8_decode($DOMElement->getAttribute($attributeName));
}

function getQueryElements($queryString){
	return createXPathQueryObject()->query($queryString);		
}

function getContentRootDestination() {
	//->item(0), because there is only one element
	return getAttributeValue(getQueryElements('/cms-config/content-root')->item(0),'dest');
}


function getContentItemByLink($linkIdentifier) {
	foreach (getContentItems() as $item)
		//if: content item was found
		if ($item->getAttribute('link') == $linkIdentifier)
			return $item;
	return NULL;
}


function getMenuItemName($menuItem){
	return getContentItemName(getContentItemByLink(getMenuItemLink($menuItem)));
}



function getContentItemCategoryByLink($linkIdentifier){
	return getContentItemCategory(getContentItemByLink($linkIdentifier));
}

function isMenuItem($linkIdentifier){
	if(getMenuItemByLink($linkIdentifier)!=NULL)
		return true;
	return false;				
}


function getMenuItemByLink($linkIdentifier){
	foreach(getMenuItems() as $menuItem)
		if(getMenuItemLink($menuItem)==$linkIdentifier)
			return $menuItem;
	return NULL;				
}


function getMenuItemLink($menuItem) {
	return getAttributeValue($menuItem,'link');
}



function getContentItemCategory($contentItem) {
	return getAttributeValue($contentItem,'category');
}

function getContentItemLink($contentItem){
	return getAttributeValue($contentItem,'link');
}


function getContentItemName($contentItem){
	return getAttributeValue($contentItem,'name');
}


function getContentLanguage($contentItem){
	return getAttributeValue($contentItem,'lang');	
}


function getMenuItems() {
	return getQueryElements('/cms-config/menu/menu-item');
}

function getContentItems() {
	return getQueryElements('/cms-config/contents/item');
}

//domain= http://www.aldana-online.de, http://localhost etc.
function getDomainURL() {
	return getDomain()->getAttribute('url');
}

function getHome() {
	return getDomain()->getAttribute('home-site');	
}

function getDomain() {
	//item(0) because only one domain element exists	
	return getQueryElements('/cms-config/domain')->item(0);
}

function getMenuItemNameByLink($linkIdentifier){
	foreach(getMenuItems() as $menu_item)
		if(getMenuItemLink($menu_item)==$linkIdentifier)
			return getMenuItemName($menu_item);
	return NULL;	  	
}


//getting name either from menu or category item
function getNameByLink($linkIdentifier){
	return getContentItemName(getContentItemByLink($linkIdentifier));
}


?>